/*
*ce projet a été développé par Galleron Evan
* version 1 : 05/2022 - 07/2022
*
*        /^^^^^\
*        \     / 
*         \   /
*          \o/
*          /T\
*          / \
*       
*/

mode = "";
elem_select = "";
debug = false;

//au lancement uniquement met sur la partie selection du mode et ferme tout les popup
function init() {
    if (debug) { alert("init()"); }

    mode = "";
    setup_jeu();
    fermer_popup();
}

//met le mode en fonction du bouton change le visuel et setup le jeu si il y a un mode
function select_mode(id_bouton) {
    if (debug) { alert("select_mode(" + id_bouton + ")"); }

    mode = id_bouton;
    if (mode) {
        setup_jeu();
        change_part();
    }
}

//met les bonne possibilités dans les menus en fonction du mode
function setup_jeu() {
    if (debug) { alert("setup_jeu()"); }

    /******************************recuperationde la couleur du bouton du mode*********************/
    var les_btn = document.getElementsByClassName("btn_selection");
     color = "rgb(255, 255, 255)";
    for (let i = 0; i < les_btn.length; i++) {
        if (les_btn[i].id === mode) {
            color = document.defaultView.getComputedStyle(les_btn[i]).getPropertyValue("background-color");
        }
            
        
    }
    


    /************************ on reset tout par soucis de d'integrité **********************************/
    gerer_clavier();
    //supprime tout les elements du menu deroulant 
    var liste = document.getElementsByClassName("menu_unites");
    for (i = 0; i < liste.length; i++) {

        while (liste[i].options.length != 0) {
            liste[i].remove(0);
        }

        //creation du premier element
        var opt = document.createElement("option");
        opt.value = 0;
        opt.text = "-------------";
        liste[i].add(opt);
    }

    //reset la reponse
    document.getElementById("resultat").innerHTML = "_________";
    document.getElementById("poubelle_sec_res").style.display = "none";
    document.getElementById("sec_res").style.margin = "0px 0px 0px 48px";

    //reset de tout les texte dans les "bloc-reponse"
    var answer = document.getElementsByClassName("inputs");
    for (i = 0; i < answer.length; i++) {
        answer[i].innerHTML = "____";
    }

    //met tout les bloc-reponse à etat de desactiver
    var liste = document.getElementsByClassName("bloc-reponse");
    for (let i = 0; i < liste.length; i++) {
        if (liste[i].hasAttribute("est_shake")) {
            liste[i].removeAttribute("style");
        }
        liste[i].style.opacity = 0.5;
        liste[i].setAttribute("disabled", "true");
        liste[i].children[0].setAttribute("disabled", "true"); //children[0] = menu deroulant
        liste[i].children[2].style.display = "none";
        liste[i].setAttribute("style","background-color:"+color+"; opacity:0.5");
    }

    //setup du premier tirage dispo
    liste[0].removeAttribute("disabled");
    liste[0].style.opacity = 1;
    liste[0].children[0].removeAttribute("disabled");
    liste[0].children[0].style.cursor = "pointer";



    /******************************** on setup enfin ******************************************/
    var unites_mode = [];
    if (mode === "zero-cent") {
        unites_mode = ["Unités", "Dizaines"];
    } else if (mode === "cent-mille") {
        unites_mode = ["Unités", "Dizaines", "Centaines"];
    } else if (mode === "mille-dixmille") {
        unites_mode = ["Unités", "Dizaines", "Centaines", "Unités de mille"];
    } else if (mode === "dixmille-milliard") {
        unites_mode = ["Unités", "Dizaines", "Centaines", "Unités de mille", "Dizaines de mille", "Centaines de mille", "Unités de millions", "Dizaines de millions", "Centaines de millions"];
    } else if (mode === "cent-centieme") {
        unites_mode = ["Millièmes", "Centièmes", "Dixièmes", "Unités", "Dizaines"];
    } else {
        //si autre on évite les probleme et on reviens au debut
        mode = "";
        change_part();
    }

    //ajout des options unités de numération dans la liste et leurs valeurs
    var liste = document.getElementsByClassName("menu_unites");
    var base = 1;
    if (unites_mode[0] === "Millièmes") {
        base = 0.001;
    }
    for (i = 0; i < liste.length; i++) {
        for (j = 0; j < unites_mode.length; j++) {
            var opt = document.createElement("option");
            opt.value = base * 10 ** j;
            opt.text = unites_mode[j];
            liste[i].add(opt);
        }
    }

}

//ferme tout les popup et remet les boutons X et ↺ 
function fermer_popup() {
    if (debug) { alert("fermer_popup()"); }

    document.getElementById("popup_fin").setAttribute("hidden", "true");
    if (getComputedStyle(document.getElementById("part_deux")).display !== "none") { gerer_bouton("afficher"); }
}

//demande confirmation, met le mode a null 
function f_close() {
    if (debug) { alert("f_close()"); }

    if (confirm("es tu sur de quitter ?")) {
        mode = "";
        setup_jeu();
        elem_select = "";

    }

}

//reset, reSet le jeu et ferme les popup
function f_restart() {
    if (debug) { alert("f_restart()"); }

    var liste = document.getElementsByClassName("bloc-reponse")
    if (confirm("es tu sur de tout recommencer ?")) {
        for (let i = 0; i < liste.length; i++) {
            liste[i].children[0].selectedIndex = 0;
            liste[i].children[1].innerHTML = "____";
        }
        gerer_clavier();

        //met tout les bloc-reponse a etat de desactiver
        var liste = document.getElementsByClassName("bloc-reponse");
        for (let i = 0; i < liste.length; i++) {
            if (liste[i].hasAttribute("est_shake")) {
                liste[i].removeAttribute("style");
            }
            liste[i].style.opacity = 0.5;
            liste[i].setAttribute("disabled", "true");
            liste[i].children[0].setAttribute("disabled", "true"); //children[0] = menu deroulant
            liste[i].setAttribute("style","background-color:"+color+"; opacity:0.5");
        }

        //setup du premier tirage dispo
        liste[0].removeAttribute("disabled");
        liste[0].style.opacity = 1;
        liste[0].children[0].removeAttribute("disabled");
        liste[0].children[0].style.cursor = "pointer";
        document.getElementById("resultat").innerHTML = "_________";

    }

}

//reactive les elements desactive, ferme les popup et le clavier
function f_retry() {
    if (debug) { alert("f_retry()"); }

    fermer_popup();
    var bloc_rep = document.getElementsByClassName("bloc-reponse")
    for (let i = 0; i < bloc_rep.length; i++) {
        if (!bloc_rep[i].hasAttribute("disabled")) { //si le bloc a pas l'attribut desactivers
            bloc_rep[i].style.opacity = 1;
            bloc_rep[i].children[0].removeAttribute("disabled");
        }
        bloc_rep[i].setAttribute("onClick", "select_elem(this)");
        bloc_rep[i].style.cursor = "pointer";
        bloc_rep[i].children[0].style.cursor = "pointer";
        bloc_rep[i].children[1].style.cursor = "pointer";

    }

}

//calcul le resultat, le compare avec celui entre et appel la fin de jeu en consequence
function f_validate() {
    if (debug) { alert("f_validate()"); }
    var probleme = est_valide();
    var elem = document.getElementsByClassName("bloc-reponse")[probleme - 1];
    nb_active = 0;
    var compteur = 0;
    var bloc_reponse = document.getElementsByClassName("bloc-reponse");
    while (compteur < bloc_reponse.length /*&& nb_active < 1*/) {
        if (!bloc_reponse[compteur].hasAttribute("disabled")) {
            nb_active++;
        }

        compteur++;
    }

    var inputs = [];
    if ((probleme === 0 || (elem.children[0].value == 0 && elem.children[1].innerHTML === "____" && nb_active > 1)) && document.getElementById("sec_res").children[1].innerHTML !== "_________" && nb_active > 0) {
        if (est_valide() !== -1) { //si aucun element est mal complete
            var liste = document.getElementsByClassName("menu_unites");
            var resolved = 0.0;
            for (i = 0; i < liste.length; i++) { //calcul du bon résultat
                if (liste[i].value && !isNaN(parseFloat(liste[i].nextElementSibling.innerHTML, 10))) {
                    resolved += liste[i].value * parseFloat(liste[i].nextElementSibling.innerHTML, 10); //next sibling = zone de texte avec les valeurs
                    inputs.push(liste[i].selectedOptions[0].innerHTML);
                    inputs.push(liste[i].nextElementSibling.innerHTML)
                }
            }

            if (debug) { alert("resultat attendu : " + resolved) }
            //recup du resultat entre
            var rep = document.getElementById("resultat");
            rep = parseFloat(rep.innerHTML.replaceAll(" ", "").replace(",", "."), 10) //formatage de l'input

            if (debug) { alert("réponse entré : " + rep) };
            //appel de la fin
            if (rep === resolved) {
                fin_jeu("win", inputs);
            } else {
                fin_jeu("loose", inputs);
            }

        }
    } else {
        gerer_clavier();
        if (document.getElementById("sec_res").children[1].innerHTML === "_________") {
            shake_elem(document.getElementById("sec_res"))
        } else if (nb_active === 0) {
            select_elem(bloc_reponse[0]);
            f_validate();
        } else { shake_elem(elem) }
    }
}

//change uniquement le visuel : partie selection (1) ou verif (2)
function change_part(part) {
    if (debug) { alert("change_part(" + part + ")"); }
    var mode_dispo = ["zero-cent", "cent-mille", "mille-dixmille", "dixmille-milliard", "cent-centieme"];
    var est_setup = false;
    var liste = document.getElementsByClassName("bloc-reponse");
    for (let i = 0; i < liste.length; i++) {
        if (liste[i].children[0].childElementCount > 2) {
            est_setup = true;
        }

    }

    //on verifie que le mode existe parmis ceux-ci dessus
    if (mode_dispo.indexOf(mode) !== -1 || mode === "") {
        var part1 = document.getElementById("part_un");
        var part2 = document.getElementById("part_deux");
        if ((!mode || part === 1) && !est_setup) {
            mode = ""
            part1.style.display = "flex";
            part2.style.display = "none";
            gerer_bouton();

        } else if ((mode || part === 2) && est_setup) {
            part2.style.display = "flex";
            part1.style.display = "none";
            gerer_bouton("afficher");
        } else { console.log("jeu pas setup") }
    }
}

//affiche ou cache les boutons de droite
function gerer_bouton(opt) {
    if (debug) { alert("gerer_bouton(" + opt + ")"); }

    if (opt == "afficher") {
        document.getElementById("btn_close").removeAttribute("hidden");
        document.getElementById("btn_restart").removeAttribute("hidden");
    } else {
        document.getElementById("btn_close").setAttribute("hidden", "true");
        document.getElementById("btn_restart").setAttribute("hidden", "true");
    }
}

//ouvre le popup de fin et desactive les elements en arriere plan
function fin_jeu(end, inputs) {
    if (debug) { alert("fin_jeu(" + end + ")"); }

    var bloc_rep = document.getElementsByClassName("bloc-reponse");
    gerer_clavier();
    gerer_bouton();

    //on desactive tout mais pas les bloc-reponses (uniquement les menu) pour la sauvegarde de contexte
    for (let i = 0; i < bloc_rep.length; i++) {
        bloc_rep[i].removeAttribute("onClick");
        bloc_rep[i].style.opacity = 0.5;
        bloc_rep[i].style.cursor = "default";
        bloc_rep[i].children[0].setAttribute("disabled", "true"); //children[0] = le menu
        bloc_rep[i].children[0].style.cursor = "default";
        bloc_rep[i].children[1].style.cursor = "default"; //children[1] = le texte
    }

    //setup du message de fin
    var texte_fin = document.getElementById("texte_fin");
    if (end === "win") {
        texte_fin.innerHTML = "Bien joué !!"
    } else if (end === "credit") {
        texte_fin.innerHTML = "Cette application a été développée par Evan Galleron. version 1 : 2022 ";
        texte_fin.nextElementSibling.innerHTML = "contact : chiffroscope@ens-lyon.fr";
    } else {
        texte_fin.innerHTML = "Dommage... Essaye encore"
    }

    if (!inputs) { //si probleme avec l'entrée
        f_retry()
    } else if (end === "win" || end === "loose" && inputs.length % 2 === 0) {
        //affichage de celui ci
        var inputs_txt = "";
        for (let i = 0; i < inputs.length; i += 2) {
            inputs_txt += inputs[i + 1] + " " + inputs[i];
            if (i + 2 < inputs.length) {
                inputs_txt += " + ";
            }
        }
        if (end === "win") {
            inputs_txt += " est égal à ";
        } else if (end === "loose") {
            inputs_txt += " n'est pas égal à ";
        }
        inputs_txt += document.getElementById("sec_res").children[1].innerHTML;
        texte_fin.nextElementSibling.innerHTML = inputs_txt;
    }
    document.getElementById("popup_fin").removeAttribute("hidden");
}

//deselectionne l'element selectionne et cache le clavier
function gerer_clavier(action) {
    if (debug) { alert("gerer_clavier(" + action + ")"); }

    var clavier = document.getElementsByClassName("clavier"); //clavier[0] == clavier gauche

    if (action === "ouvrir" && elem_select && getComputedStyle(document.getElementById("part_deux")).display !== "none") {
        if (elem_select === document.getElementById("sec_res")) { //&& getComputedStyle(clavier[1]).display !== "none") {
            clavier[1].style.opacity = 1;
            clavier[1].children[0].style.display = ""; //c'est la petite croix pour fermer le clavier
            clavier[1].children[1].style.display = ""; //c'est toutes les touches du clavier

            clavier[0].style.opacity = 0;
            clavier[0].children[0].style.display = "none";
            clavier[0].children[1].style.display = "none";

        } else if (elem_select !== document.getElementById("sec_res") && getComputedStyle(clavier[0]).display !== "none") {
            clavier[0].style.opacity = 1;
            clavier[0].children[0].style.display = ""; //c'est la petite croix pour fermer le clavier
            clavier[0].children[1].style.display = ""; //c'est toutes les touches du clavier

            clavier[1].style.opacity = 0;
            clavier[1].children[0].style.display = "none";
            clavier[1].children[1].style.display = "none";

        }


    } else {
        //en cas de pb avec elem select
        try { unselect(); } catch (error) { console.log("tu as essayer de frauder la non ?") }
        clavier[0].style.opacity = 0;
        clavier[0].children[0].style.display = "none";
        clavier[0].children[1].style.display = "none";

        clavier[1].style.opacity = 0;
        clavier[1].children[0].style.display = "none";
        clavier[1].children[1].style.display = "none";
    }

}

//si un elem etait deja selectionner il le deselectionne et selectionne celui en parametre (ferme le clavier si rien)
function select_elem(elem) {
    if (debug) { if (elem) { alert("select_elem(" + elem.innerHTML + ")"); } else { alert("select_elem(" + elem + ")"); } }

    var probleme = est_valide();
    var liste = document.getElementsByClassName("bloc-reponse");

    if (elem.hasAttribute("est_clear")) {
        elem.removeAttribute("est_clear");
        gerer_clavier();
        elem.children[1].innerHTML = "____";
        elem.style.opacity = 0.5;
        elem.setAttribute("disabled", "true");
        elem.children[0].setAttribute("disabled", "true"); //children[0] = menu deroulant
        elem.children[0].selectedIndex = 0;
        elem.children[2].style.display = "none";

    } else if (elem.hasAttribute("disabled") && probleme !== 0) {
        gerer_clavier();
        shake_elem(liste[probleme - 1]);

    } else {
        unselect();
        elem_select = elem;
        elem.setAttribute("style", "border:solid 3px black;background-color: #F2E205;");
        gerer_clavier("ouvrir");
        gerer_virgule();
        if (elem !== document.getElementById("sec_res")) {
            elem.children[0].removeAttribute("disabled");
            elem.removeAttribute("disabled");
            elem.children[2].style.display = "";
        } else {
            document.getElementById("poubelle_sec_res").style.display = "";
        }
    }


}

//va activer ou non la virgule
function gerer_virgule() {
    if (debug) { alert("gerer_virgule()"); }
    var virgule = document.getElementById("virgule");
    //si on est dans la section reponse, qu'il n'y a pas deja de virgule et que le mode choisis a des décimal
    if (elem_select === document.getElementById("sec_res") && elem_select.children[1].innerHTML.indexOf(',') === -1 && mode === "cent-centieme") {
        virgule.style.opacity = 1;
        virgule.style.cursor = "pointer";
        virgule.removeAttribute("disabled");
    } else {
        virgule.style.opacity = 0;
        virgule.style.cursor = "default";
        virgule.setAttribute("disabled", "true");
    }
}

//deselectionne l'element selectionne en remettant ses parametres css de base
function unselect() {
    if (debug) { alert("unselect()"); }
    if (elem_select == document.getElementById("sec_res")) {
        elem_select.removeAttribute("style");
        document.getElementById("poubelle_sec_res").style.display = "none";
        elem_select.style.margin = "0px 0px 0px 48px";

    } else if (elem_select) {
        elem_select.setAttribute("style", "border:solid 3px grey; background-color:"+color);

        elem_select.children[2].style.display = "none";
    }
    elem_select = "";
}

//ecrit dans l'elem selectionne avec la valeur texte html du bouton
function btn_click(btn) {
    var tentative_de_fraude = true;
    try { if (elem_select.getAttribute("onClick") === "select_elem(this)") { tentative_de_fraude = false; } } catch (error) { }
    if (!tentative_de_fraude) {
        var la_chaine = elem_select.children[1].innerHTML;

        //met a vide si il y avait rien
        if (la_chaine === "____" || la_chaine === "_________") {
            la_chaine = "";
        }

        //si c'est pas la virgule et qu'il n'y en a pas
        if (btn !== document.getElementById("virgule") && elem_select.children[1].innerHTML.indexOf(',') === -1) {
            la_chaine += btn.innerHTML;
            la_chaine = format_str(la_chaine);
            elem_select.children[1].innerHTML = la_chaine;

        //sinon si c'est la virgule
        } else if (btn === document.getElementById("virgule")) {
            la_chaine = la_chaine + btn.innerHTML;
            elem_select.children[1].innerHTML = la_chaine;
            gerer_virgule();

        //sinon si il y a une virgule et que la chaine est pas trop longue et qu'il y moins de 3 chiffres apres la virgule 
        } else if (la_chaine.length < 19 && elem_select.children[1].innerHTML.indexOf(',') !== -1 && la_chaine.slice(la_chaine.indexOf(',') + 1).length < 3) {

            la_chaine = la_chaine + btn.innerHTML;
            elem_select.children[1].innerHTML = la_chaine;

        }

        //si on est pas dans sec_res et qu'on est au dessus de 99
        if (elem_select !== document.getElementById("sec_res") && la_chaine > 99) {
            //elem_select.children[1].innerHTML = "____"; //option 1 remettre par défaut
            //elem_select.children[1].innerHTML = 99;  //option 2 cap à 99
            elem_select.children[1].innerHTML = la_chaine.slice(0, -1); //option 3 annuler la touche  
        }

    } else { gerer_clavier(); }
}

//remet le placeholder de base et si c'est un bloc reponses remet l'element du menu unites de base et en pointillé
function clear_zone() {
    if (debug) { alert("clear_zone()") }
    if (elem_select) {
        if (elem_select === document.getElementById("sec_res")) {
            elem_select.children[1].innerHTML = "_________";
            gerer_virgule();
        } else {

            elem_select.setAttribute("disabled", "true");
            elem_select.setAttribute("est_clear", "true");

        }
    }

}

//si les infos rentrée sont invalide, on le shake.
function est_valide() {
    var liste = document.getElementsByClassName("bloc-reponse");
    var est_pas_bon = false;
    for (let i = 0; i < liste.length; i++) {

    }
    var i = 0;
    while (i < liste.length && !est_pas_bon) {
        if (!liste[i].hasAttribute("disabled") && (liste[i].children[0].value == 0 || liste[i].children[1].innerHTML === "____")) {
            est_pas_bon = true;
        }
        i++;
    }

    if (!est_pas_bon) {
        return 0;
    } else {
        return i;
    }
}

//fait shake un element parmis les bloc-reponse ou le sec_res
function shake_elem(elem) {
    try {
        if (elem.getAttribute("class").indexOf("bloc-reponse") !== -1) {
            elem.style.animation = "shake 0.7s infinite";
            elem.style.border = "solid 3px red";
            elem.setAttribute("est_shake", "true");
        }
    } catch (error) {
        if (elem === document.getElementById("sec_res")) {
            elem.style.animation = "shake 0.7s infinite";
            elem.style.border = "solid 3px red";
            elem.setAttribute("est_shake", "true");
        }
    }
}

//supprime le dernier caractere de elem_select
function eff() {
    if (elem_select && elem_select.children[1].innerHTML !== "____" && elem_select.children[1].innerHTML !== "_________") {
        elem_select.children[1].innerHTML = format_str(elem_select.children[1].innerHTML.slice(0, -1));
        if (elem_select.children[1].innerHTML === "") {
            if (elem_select === document.getElementById("sec_res")) {
                elem_select.children[1].innerHTML = "_________";
            } else {
                elem_select.children[1].innerHTML = "____";
            }
        }
        gerer_virgule();
    }
}

function format_str(str_a_format) {

    //formatage de la chaine pour reconstruction
    var chaine_tmp = str_a_format.replaceAll(" ", "");


    //pour mettre un espace entre les blocs de trois chiffresmais pas après la virgule
    if (elem_select.children[1].innerHTML.indexOf(',') === -1 && chaine_tmp.length < 13) {
        str_a_format = "";
        if (chaine_tmp.length % 3 === 2) {
            for (let i = 0; i < chaine_tmp.length; i++) {
                str_a_format += chaine_tmp[i]
                if (i % 3 == 1) {
                    str_a_format += " ";
                }
            }
            str_a_format = str_a_format.slice(0, -1); //on enlève le dernier pour la virgule
        } else if (chaine_tmp.length % 3 === 1) {
            for (let i = 0; i < chaine_tmp.length; i++) {
                str_a_format += chaine_tmp[i]
                if (i % 3 == 0) {
                    str_a_format += " ";
                }
            }
            str_a_format = str_a_format.slice(0, -1); //on enlève le dernier pour la virgule
        } else if (chaine_tmp.length % 3 === 0) {
            for (let i = 0; i < chaine_tmp.length; i++) {
                str_a_format += chaine_tmp[i]
                if (i % 3 == 2) {
                    str_a_format += " ";
                }
            }
            str_a_format = str_a_format.slice(0, -1); //on enlève le dernier pour la virgule
        }
    }
    return str_a_format;
}


